(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/common'), require('@angular/core'), require('@angular/forms'), require('@ui-model/angular'), require('@ui-model/common'), require('util'), require('@ui-model/core'), require('rxjs'), require('rxjs/operators')) :
    typeof define === 'function' && define.amd ? define('@ui-model/angular-bootstrap', ['exports', '@angular/common', '@angular/core', '@angular/forms', '@ui-model/angular', '@ui-model/common', 'util', '@ui-model/core', 'rxjs', 'rxjs/operators'], factory) :
    (global = global || self, factory((global['ui-model'] = global['ui-model'] || {}, global['ui-model']['angular-bootstrap'] = {}), global.ng.common, global.ng.core, global.ng.forms, global.angular, global.common$1, global.util, global.core$1, global.rxjs, global.rxjs.operators));
}(this, function (exports, common, core, forms, angular, common$1, util, core$1, rxjs, operators) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */
    /* global Reflect, Promise */

    var extendStatics = function(d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };

    function __extends(d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    }

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var CalendarComponent = /** @class */ (function (_super) {
        __extends(CalendarComponent, _super);
        function CalendarComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.change = new core.EventEmitter();
            return _this;
        }
        /**
         * @return {?}
         */
        CalendarComponent.prototype.close = /**
         * @return {?}
         */
        function () {
            this.change.emit(this.value);
        };
        CalendarComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-calendar',
                        template: "<table [class.diabled]=\"disabled\">\n  <caption>\n    <div>\n      <a (click)=\"goToPrevMonth()\" href=\"javascript:void(0)\" title=\"Previous Month\">\n        <i class=\"fa fa-chevron-left\"></i>\n      </a>\n      <select [(ngModel)]=\"month\" class=\"form-control\" name=\"month\">\n        <option *ngFor=\"let month of monthNames;let index = index\" [ngValue]=\"index\">{{month}}</option>\n      </select>\n      <select [(ngModel)]=\"year\" class=\"form-control\" name=\"year\">\n        <option *ngFor=\"let year of nearlyYears\" [ngValue]=\"year\">{{year}}</option>\n      </select>\n      <a (click)=\"clear()\" href=\"javascript:void(0)\" title=\"Clear\">\n        <i class=\"fa fa-close\"></i>\n      </a>\n      <a (click)=\"goToToday()\" href=\"javascript:void(0)\" title=\"Today\">\n        <i class=\"fa fa-map-marker\"></i>\n      </a>\n      <a (click)=\"goToNextMonth()\" href=\"javascript:void(0)\" title=\"Next Month\">\n        <i class=\"fa fa-chevron-right\"></i>\n      </a>\n    </div>\n  </caption>\n  <thead>\n  <tr>\n    <th></th>\n    <th *ngFor=\"let name of weekdayNames\">{{name}}</th>\n  </tr>\n  </thead>\n  <tbody>\n  <tr *ngFor=\"let week of weeks\">\n    <td class=\"week\">\n      {{week}}\n    </td>\n    <td *ngFor=\"let day of dates(week)\"\n        (click)=\"goTo(day); close()\"\n        [class.active]=\"isActive(day)\"\n        [class.other-month]=\"!inSameMonth(day)\"\n        [class.today]=\"isToday(day)\"\n        [class.weekend]=\"isWeekEnd(day)\"\n    >\n      {{day.getDate()}}\n    </td>\n  </tr>\n  </tbody>\n</table>\n<div *ngIf=\"disabled\" class=\"disabled-mask\"></div>\n",
                        providers: [{
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: CalendarComponent,
                                multi: true,
                            }],
                        styles: [":host{display:block;position:relative;overflow:hidden;border-radius:.25rem}.disabled-mask{position:absolute;top:0;left:0;width:100%;height:100%;background:rgba(173,181,189,.1)}caption{caption-side:top;padding:0;text-align:center}caption>div{display:table;width:100%}caption>div>*{display:table-cell;width:auto}caption>div>.form-control{border:none;width:50%}caption a{color:#adb5bd}caption a:focus,caption a:hover{color:#0056b3}.icon{vertical-align:middle}table{margin:auto}th{text-align:center}td{padding:.2em .5em;text-align:center;vertical-align:middle;cursor:pointer}td.week{padding-left:.2em;padding-right:.2em;color:#adb5bd;font-size:smaller;border-right:1px solid #dee2e6}td.weekend{color:#adb5bd}td.other-month{color:#dee2e6}td.today{color:#f8f9fa;background:#17a2b8}td.active{background:#007bff;color:#f8f9fa}"]
                    }] }
        ];
        CalendarComponent.propDecorators = {
            disabled: [{ type: core.Input }],
            change: [{ type: core.Output }]
        };
        return CalendarComponent;
    }(angular.CalendarValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var DatePickerComponent = /** @class */ (function () {
        function DatePickerComponent() {
            this.toggle = new common$1.Toggle();
            this.disabled = false;
        }
        Object.defineProperty(DatePickerComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._value = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} obj
         * @return {?}
         */
        DatePickerComponent.prototype.writeValue = /**
         * @param {?} obj
         * @return {?}
         */
        function (obj) {
            this.value = obj;
        };
        /**
         * @return {?}
         */
        DatePickerComponent.prototype.changed = /**
         * @return {?}
         */
        function () {
            if (this._onChange) {
                this._onChange(this.value);
            }
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onChange = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        DatePickerComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._onTouched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        DatePickerComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @protected
         * @return {?}
         */
        DatePickerComponent.prototype.touched = /**
         * @protected
         * @return {?}
         */
        function () {
            if (this._onTouched) {
                this._onTouched();
            }
        };
        DatePickerComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-date-picker',
                        template: "<div (uiClickOutside)=\"toggle.close()\" class=\"dropdown\">\n  <div class=\"input-group\">\n    <input (ngModelChange)=\"changed()\" [(ngModel)]=\"value\" [disabled]=\"disabled\" class=\"form-control\" type=\"text\"\n           uiDateInput/>\n    <div class=\"input-group-append\">\n      <button (click)=\"toggle.toggle()\" [disabled]=\"disabled\" class=\"btn btn-primary\" type=\"button\">\n        <i class=\"fa fa-calendar\"></i>\n      </button>\n    </div>\n  </div>\n  <div *ngIf=\"!disabled && toggle.isOn\" class=\"dropdown-menu\">\n    <ui-calendar (change)=\"toggle.close()\" (ngModelChange)=\"changed()\" [(ngModel)]=\"value\" name=\"date\"></ui-calendar>\n  </div>\n</div>\n",
                        providers: [
                            { provide: forms.NG_VALUE_ACCESSOR, multi: true, useExisting: DatePickerComponent },
                        ],
                        styles: [":host{display:block}.dropdown .dropdown-menu{display:block;width:100%;margin-top:0;padding:1rem}"]
                    }] }
        ];
        /** @nocollapse */
        DatePickerComponent.ctorParameters = function () { return []; };
        DatePickerComponent.propDecorators = {
            disabled: [{ type: core.Input }]
        };
        return DatePickerComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FieldErrorComponent = /** @class */ (function () {
        function FieldErrorComponent(group, form) {
            this.group = group;
            this.form = form;
        }
        Object.defineProperty(FieldErrorComponent.prototype, "fieldName", {
            get: /**
             * @return {?}
             */
            function () {
                return this._fieldName;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._fieldName !== value) {
                    this._fieldName = value;
                    this.fieldNameChanged();
                }
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        FieldErrorComponent.prototype.fieldNameChanged = /**
         * @return {?}
         */
        function () {
            if (!this.fieldName) {
                return;
            }
            if (this.group) {
                this.field = this.group.control.get(this.fieldName);
            }
            else if (this.form) {
                this.field = this.form.control.get(this.fieldName);
            }
        };
        /**
         * @return {?}
         */
        FieldErrorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            this.fieldNameChanged();
        };
        FieldErrorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-field-error',
                        template: "<div *ngIf=\"field\">\n  <div *ngIf=\"field.pending\" class=\"text-warning\">\n    <i class=\"fa fa-spinner fa-spin\"></i>\n    checking...\n  </div>\n  <ul *ngIf=\"!field.pristine && field.invalid && field.errors\" class=\"text-danger\">\n    <li *ngFor=\"let error of field.errors | objectToArray\"\n        [innerHTML]=\"error|fieldErrorMapper:messages|template:error|safeHtml\"></li>\n  </ul>\n</div>\n",
                        styles: [":host{display:block}ul{margin-bottom:0}"]
                    }] }
        ];
        /** @nocollapse */
        FieldErrorComponent.ctorParameters = function () { return [
            { type: forms.FormGroupName, decorators: [{ type: core.Optional }] },
            { type: forms.FormGroupDirective, decorators: [{ type: core.Optional }] }
        ]; };
        FieldErrorComponent.propDecorators = {
            field: [{ type: core.Input }],
            messages: [{ type: core.Input }],
            fieldName: [{ type: core.Input }]
        };
        return FieldErrorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormArrayComponent = /** @class */ (function () {
        function FormArrayComponent() {
            this.readonly = false;
        }
        /**
         * @return {?}
         */
        FormArrayComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        FormArrayComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-form-array',
                        template: "<div *ngIf=\"field\" [formGroup]=\"group\">\n  <div #values=\"uiFormArray\" [formArrayName]=\"field.name\" class=\"form-group\">\n    <label *ngIf=\"field | fieldLabel\" for=\"values\">{{field | fieldLabel}}</label>\n    <div *ngFor=\"let control of values.items\" class=\"form-group\">\n      <div class=\"input-group\">\n        <input [formControl]=\"control\" class=\"form-control\" id=\"values\" name=\"values\" type=\"text\"/>\n        <div class=\"input-group-append\">\n          <button (click)=\"values.removeItem(control)\" [disabled]=\"control.disabled\" class=\"btn btn-primary\">\n            <i class=\"fa fa-close\"></i>\n          </button>\n        </div>\n      </div>\n      <ui-field-error [field]=\"control\"></ui-field-error>\n    </div>\n    <div>\n      <button (click)=\"values.createItem()\" [disabled]=\"group.disabled || group.root.disabled\" class=\"btn btn-primary\"\n              type=\"button\">\n        <i class=\"fa fa-plus-circle\"></i>\n        Add a new tag\n      </button>\n    </div>\n  </div>\n</div>\n",
                        styles: [":host{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        FormArrayComponent.ctorParameters = function () { return []; };
        FormArrayComponent.propDecorators = {
            group: [{ type: core.Input }],
            field: [{ type: core.Input }],
            readonly: [{ type: core.Input }]
        };
        return FormArrayComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormControlComponent = /** @class */ (function () {
        function FormControlComponent(injector) {
            this.injector = injector;
            this.readonly = false;
            this.uniqueId = ++FormControlComponent.latestUniqueId;
        }
        Object.defineProperty(FormControlComponent.prototype, "control", {
            get: /**
             * @return {?}
             */
            function () {
                if (!this.group || !this.field) {
                    return;
                }
                return this.group.get(this.field.name);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        FormControlComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isCustomEditor = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return util.isFunction(field.editor);
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isInput = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return !field.editor || util.isString(field.editor) && field.editor !== 'textarea';
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isTextArea = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return field.editor === 'textarea';
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isRequired = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return field.validators && field.validators.indexOf(forms.Validators.required) !== -1;
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isPlainText = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return field.type === String;
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isNumber = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return field.type === Number;
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isDate = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return field.type === Date;
        };
        /**
         * @param {?} field
         * @return {?}
         */
        FormControlComponent.prototype.isCustomViewer = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            return util.isFunction(field.viewer);
        };
        FormControlComponent.latestUniqueId = new Date().getTime();
        FormControlComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-form-control',
                        template: "<div *ngIf=\"group && field\" [class.ui-required]=\"!readonly && isRequired(field)\" [formGroup]=\"group\"\n     class=\"form-group\">\n  <label *ngIf=\"field | fieldLabel\" for=\"_{{field.name}}_{{uniqueId}}\">{{field | fieldLabel}}</label>\n  <ng-container *ngIf=\"!readonly\">\n    <ng-container *ngIf=\"isInput(field)\">\n      <input [formControl]=\"control\" [readonly]=\"field.readonly\" [step]=\"field.editorInputs?.step\"\n             [type]=\"field.editor || 'text'\"\n             class=\"form-control\" id=\"_{{field.name}}_{{uniqueId}}\"/>\n    </ng-container>\n    <ng-container *ngIf=\"isTextArea(field)\">\n    <textarea [formControl]=\"control\" [readonly]=\"field.readonly\"\n              class=\"form-control\" id=\"_{{field.name}}_{{uniqueId}}\"></textarea>\n    </ng-container>\n    <div *ngIf=\"isCustomEditor(field)\" [ngComponentOutletInjector]=\"injector\" [ngComponentOutlet]=\"field.editor\"\n         [uiDynamicComponentInputs]=\"[field.editorInputs, {name: field.name, field: field}]\"></div>\n  </ng-container>\n  <div *ngIf=\"readonly\" class=\"form-control-plaintext\">\n    <div *ngIf=\"isCustomViewer(field)\" [ngComponentOutletInjector]=\"injector\" [ngComponentOutlet]=\"field.viewer\"\n         [uiDynamicComponentInputs]=\"[field.viewerInputs, {name: field.name, field: field}]\"></div>\n    <ng-container *ngIf=\"!isCustomViewer(field)\">\n      <div *ngIf=\"isPlainText(field)\">{{control.value | default : '-'}}</div>\n      <div *ngIf=\"isDate(field)\">{{control.value | date:field.viewerInputs?.format | default: '-' }}</div>\n      <div *ngIf=\"isNumber(field)\">\n        <ng-container *ngIf=\"field.viewerInputs?.format === 'percent'\">\n          {{control.value | percent | default: '(NaN)'}}\n        </ng-container>\n        <ng-container *ngIf=\"field.viewerInputs?.format !== 'percent'\">\n          {{control.value | number:field.viewerInputs?.format | default: '(NaN)'}}\n        </ng-container>\n      </div>\n    </ng-container>\n  </div>\n</div>\n",
                        styles: [":host{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        FormControlComponent.ctorParameters = function () { return [
            { type: core.Injector }
        ]; };
        FormControlComponent.propDecorators = {
            group: [{ type: core.Input }],
            field: [{ type: core.Input }],
            readonly: [{ type: core.Input }]
        };
        return FormControlComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FormGroupComponent = /** @class */ (function () {
        function FormGroupComponent() {
            this.readonly = false;
        }
        Object.defineProperty(FormGroupComponent.prototype, "form", {
            get: /**
             * @return {?}
             */
            function () {
                return this.group && this.group[angular.metaKeyModel];
            },
            enumerable: true,
            configurable: true
        });
        FormGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-form-group',
                        template: "<div *ngIf=\"form && group\" [formGroup]=\"group\" class=\"row\">\n  <ng-container *ngFor=\"let field of form.properties\">\n    <div *ngIf=\"!field.hidden\" [ngClass]=\"field|fieldCss\" [uiFieldMetadata]=\"field\">\n      <ui-form-control *ngIf=\"field.isControl\" [field]=\"field\" [group]=\"group\" [readonly]=\"readonly\"></ui-form-control>\n      <ui-form-array *ngIf=\"field.isArray\" [field]=\"field\" [group]=\"group\" [readonly]=\"readonly\"></ui-form-array>\n      <fieldset *ngIf=\"field.isGroup\">\n        <legend>{{field.label}}</legend>\n        <ui-form-group [group]=\"group.get(field.name)\" [readonly]=\"readonly\"></ui-form-group>\n      </fieldset>\n      <ui-field-error [fieldName]=\"field.name\" [messages]=\"field.errors\"></ui-field-error>\n    </div>\n  </ng-container>\n</div>\n",
                        styles: [":host{display:block}*+ui-field-error{position:relative;top:-1em}"]
                    }] }
        ];
        FormGroupComponent.propDecorators = {
            group: [{ type: core.Input }],
            readonly: [{ type: core.Input }]
        };
        return FormGroupComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalListComponent = /** @class */ (function () {
        function ModalListComponent(modal, injector) {
            this.modal = modal;
            this.injector = injector;
        }
        /**
         * @return {?}
         */
        ModalListComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalListComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-list',
                        template: "<ui-modal *ngFor=\"let item of modal.items\">\n  <ui-modal-info *ngIf=\"item.type === 'info'\"\n                 (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, true)\" [icon]=\"item.icon\"\n                 [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-info>\n  <ui-modal-success *ngIf=\"item.type === 'success'\"\n                    (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, true)\" [icon]=\"item.icon\"\n                    [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-success>\n  <ui-modal-warning *ngIf=\"item.type === 'warning'\"\n                    (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, true)\" [icon]=\"item.icon\"\n                    [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-warning>\n  <ui-modal-error *ngIf=\"item.type === 'error'\"\n                  (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, true)\" [icon]=\"item.icon\"\n                  [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-error>\n  <ui-modal-confirm *ngIf=\"item.type === 'confirm'\"\n                    (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, $event)\" [icon]=\"item.icon\"\n                    [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-confirm>\n  <ui-modal-prompt *ngIf=\"item.type === 'prompt'\"\n                   (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, $event)\" [defaultValue]=\"item.data\"\n                   [icon]=\"item.icon\"\n                   [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-prompt>\n  <ui-modal-form *ngIf=\"item.type === 'form'\"\n                 (cancel)=\"modal.cancel(item)\" (close)=\"modal.close(item, $event)\" [group]=\"item.data\"\n                 [icon]=\"item.icon\"\n                 [message]=\"item.message\" [title]=\"item.title\">\n  </ui-modal-form>\n  <ng-container *ngIf=\"item.type === 'custom'\">\n    <div [ngComponentOutletInjector]=\"injector\" [ngComponentOutlet]=\"item.customComponent\"\n         [uiDynamicComponentInputs]=\"[item.customInputs, {modal: item}]\"></div>\n  </ng-container>\n</ui-modal>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalListComponent.ctorParameters = function () { return [
            { type: angular.ModalService },
            { type: core.Injector }
        ]; };
        return ModalListComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalConfirmComponent = /** @class */ (function () {
        function ModalConfirmComponent() {
            this.close = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalConfirmComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalConfirmComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-confirm',
                        template: "<div class=\"modal-header bg-warning text-white\">\n  <h5 class=\"modal-title\">\n    {{title|default:'Confirm'}}\n  </h5>\n  <button (click)=\"close.emit(false)\" aria-label=\"Close\" class=\"close text-white\" tabindex=\"-1\"\n          type=\"button\">\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n<div class=\"modal-body\">\n  <div class=\"row\">\n    <div class=\"col-auto\">\n      <i [ngClass]=\"icon|default:'fa-check-circle-o'\" class=\"fa fa-5x text-primary\"></i>\n    </div>\n    <div class=\"col\">\n      {{message}}\n    </div>\n  </div>\n</div>\n<div class=\"modal-footer\">\n  <button type=\"button\" class=\"btn btn-warning\" (click)=\"close.emit(true)\">\n    <span i18n>Yes</span>\n  </button>\n  <button type=\"button\" class=\"btn btn-secondary\" (click)=\"close.emit(false)\">\n    <span i18n>No</span>\n  </button>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalConfirmComponent.ctorParameters = function () { return []; };
        ModalConfirmComponent.propDecorators = {
            close: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalConfirmComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalErrorComponent = /** @class */ (function () {
        function ModalErrorComponent() {
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalErrorComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalErrorComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-error',
                        template: "<div class=\"modal-header bg-danger text-white\">\n  <h5 class=\"modal-title\">\n    {{title|default:'Error'}}\n  </h5>\n  <button (click)=\"cancel.emit()\" aria-label=\"Close\" class=\"close text-white\" tabindex=\"-1\" type=\"button\">\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n<div class=\"modal-body\">\n  <div class=\"row\">\n    <div class=\"col-auto\">\n      <i [ngClass]=\"icon|default:'fa-times-circle'\" class=\"fa fa-5x text-danger\"></i>\n    </div>\n    <div class=\"col\">\n      {{message}}\n    </div>\n  </div>\n</div>\n<div class=\"modal-footer\">\n  <button type=\"button\" class=\"btn btn-danger\" (click)=\"close.emit()\">\n    <span i18n>Ok</span>\n  </button>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalErrorComponent.ctorParameters = function () { return []; };
        ModalErrorComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalErrorComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalFormComponent = /** @class */ (function () {
        function ModalFormComponent() {
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalFormComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-form',
                        template: "<form (submit)=\"close.emit(group.value)\">\n  <div class=\"modal-header\">\n    <h5 class=\"modal-title\">\n      {{title|default:'Form'}}\n    </h5>\n    <button (click)=\"cancel.emit()\" aria-label=\"Close\" class=\"close\" tabindex=\"-1\" type=\"button\">\n      <span aria-hidden=\"true\">&times;</span>\n    </button>\n  </div>\n  <div class=\"modal-body\">\n    <div class=\"row\">\n      <div class=\"col-auto\">\n        <i [ngClass]=\"icon|default:'fa-pencil-square-o'\" class=\"fa fa-5x text-success\"></i>\n      </div>\n      <div class=\"col\">\n        <h4>{{message}}</h4>\n        <ui-form-group [group]=\"group\"></ui-form-group>\n      </div>\n    </div>\n  </div>\n  <div class=\"modal-footer\">\n    <button class=\"btn btn-primary\" type=\"submit\">\n      <span i18n>Submit</span>\n    </button>\n    <button (click)=\"cancel.emit()\" class=\"btn btn-secondary\" type=\"button\">\n      <span i18n>Cancel</span>\n    </button>\n  </div>\n</form>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalFormComponent.ctorParameters = function () { return []; };
        ModalFormComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            group: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalFormComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalInfoComponent = /** @class */ (function () {
        function ModalInfoComponent() {
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalInfoComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalInfoComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-info',
                        template: "<div class=\"modal-header bg-info text-white\">\n  <h5 class=\"modal-title\">\n    {{title|default:'Info'}}\n  </h5>\n  <button (click)=\"cancel.emit()\" aria-label=\"Close\" class=\"close text-white\" tabindex=\"-1\" type=\"button\">\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n<div class=\"modal-body\">\n  <div class=\"row\">\n    <div class=\"col-auto\">\n      <i [ngClass]=\"icon|default:'fa-info-circle'\" class=\"fa fa-5x text-info\"></i>\n    </div>\n    <div class=\"col\">\n      {{message}}\n    </div>\n  </div>\n</div>\n<div class=\"modal-footer\">\n  <button type=\"button\" class=\"btn btn-info\" (click)=\"close.emit()\">\n    <span i18n>Ok</span>\n  </button>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalInfoComponent.ctorParameters = function () { return []; };
        ModalInfoComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalInfoComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PromptModel = /** @class */ (function () {
        function PromptModel() {
        }
        __decorate([
            angular.Property({
                label: '',
            }),
            __metadata("design:type", String)
        ], PromptModel.prototype, "result", void 0);
        PromptModel = __decorate([
            angular.Model()
        ], PromptModel);
        return PromptModel;
    }());
    var ModalPromptComponent = /** @class */ (function () {
        function ModalPromptComponent(formMaker) {
            this.formMaker = formMaker;
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
            this.formGroup = this.formMaker.createFromModel(PromptModel);
        }
        Object.defineProperty(ModalPromptComponent.prototype, "defaultValue", {
            get: /**
             * @return {?}
             */
            function () {
                return this.formGroup.value && this.formGroup.value.result;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.formGroup.setValue({ result: value || '' });
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @return {?}
         */
        ModalPromptComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalPromptComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-prompt',
                        template: "<ui-modal-form (cancel)=\"cancel.emit()\" (close)=\"close.emit($event.result)\" [group]=\"formGroup\" [icon]=\"icon\"\n               [message]=\"message\" [title]=\"title|default:'Prompt'\">\n</ui-modal-form>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalPromptComponent.ctorParameters = function () { return [
            { type: angular.FormMaker }
        ]; };
        ModalPromptComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }],
            defaultValue: [{ type: core.Input }]
        };
        return ModalPromptComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalSuccessComponent = /** @class */ (function () {
        function ModalSuccessComponent() {
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalSuccessComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalSuccessComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-success',
                        template: "<div class=\"modal-header bg-success text-white\">\n  <h5 class=\"modal-title\">\n    {{title|default:'Success'}}\n  </h5>\n  <button (click)=\"cancel.emit()\" aria-label=\"Close\" class=\"close text-white\" tabindex=\"-1\" type=\"button\">\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n<div class=\"modal-body\">\n  <div class=\"row\">\n    <div class=\"col-auto\">\n      <i [ngClass]=\"icon|default:'fa-check-circle'\" class=\"fa fa-5x text-success\"></i>\n    </div>\n    <div class=\"col\">\n      {{message}}\n    </div>\n  </div>\n</div>\n<div class=\"modal-footer\">\n  <button type=\"button\" class=\"btn btn-success\" (click)=\"close.emit()\">\n    <span i18n>Ok</span>\n  </button>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalSuccessComponent.ctorParameters = function () { return []; };
        ModalSuccessComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalSuccessComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalWarningComponent = /** @class */ (function () {
        function ModalWarningComponent() {
            this.close = new core.EventEmitter();
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalWarningComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ModalWarningComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal-warning',
                        template: "<div class=\"modal-header bg-warning text-white\">\n  <h5 class=\"modal-title\">\n    {{title|default:'Warning'}}\n  </h5>\n  <button (click)=\"cancel.emit()\" aria-label=\"Close\" class=\"close text-white\" tabindex=\"-1\" type=\"button\">\n    <span aria-hidden=\"true\">&times;</span>\n  </button>\n</div>\n<div class=\"modal-body\">\n  <div class=\"row\">\n    <div class=\"col-auto\">\n      <i [ngClass]=\"icon|default:'fa-exclamation-circle'\" class=\"fa fa-5x text-warning\"></i>\n    </div>\n    <div class=\"col\">\n      {{message}}\n    </div>\n  </div>\n</div>\n<div class=\"modal-footer\">\n  <button type=\"button\" class=\"btn btn-warning\" (click)=\"close.emit()\">\n    <span i18n>Ok</span>\n  </button>\n</div>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        ModalWarningComponent.ctorParameters = function () { return []; };
        ModalWarningComponent.propDecorators = {
            close: [{ type: core.Output }],
            cancel: [{ type: core.Output }],
            title: [{ type: core.Input }],
            message: [{ type: core.Input }],
            icon: [{ type: core.Input }]
        };
        return ModalWarningComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ModalComponent = /** @class */ (function () {
        function ModalComponent() {
            this.cancel = new core.EventEmitter();
        }
        /**
         * @return {?}
         */
        ModalComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        /**
         * @return {?}
         */
        ModalComponent.prototype.doCancel = /**
         * @return {?}
         */
        function () {
            this.cancel.emit();
        };
        ModalComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-modal',
                        template: "<div class=\"modal-backdrop fade\"></div>\n<div class=\"modal\">\n  <div class=\"modal-dialog\" role=\"document\">\n    <div class=\"modal-content\" (uiClickOutside)=\"doCancel()\">\n      <ng-content></ng-content>\n    </div>\n  </div>\n</div>\n",
                        styles: [":host{display:block}.modal{display:block}.modal-backdrop{opacity:.5}"]
                    }] }
        ];
        ModalComponent.propDecorators = {
            cancel: [{ type: core.Output }]
        };
        return ModalComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var MultiSelectBoxComponent = /** @class */ (function () {
        function MultiSelectBoxComponent() {
        }
        /**
         * @return {?}
         */
        MultiSelectBoxComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        MultiSelectBoxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-multi-select-box',
                        template: "<p>\n  multi-select-box works!\n</p>\n",
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        MultiSelectBoxComponent.ctorParameters = function () { return []; };
        return MultiSelectBoxComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PaginationComponent = /** @class */ (function () {
        function PaginationComponent() {
            this.showBrief = true;
            this.showPrevNext = true;
            this.showFirstLast = true;
        }
        PaginationComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-pagination',
                        template: "<ul class=\"pagination\">\n  <li *ngIf=\"showFirstLast\" [class.disabled]=\"!pager.hasFirst\" class=\"page-item\">\n    <a (click)=\"pager.goToFirst()\" class=\"page-link\" href=\"javascript:void(0)\" title=\"First\">\n      <i class=\"fa fa-step-backward\"></i>\n    </a>\n  </li>\n  <li *ngIf=\"showPrevNext\" [class.disabled]=\"!pager.hasPrev\" class=\"page-item\">\n    <a (click)=\"pager.prev()\" class=\"page-link\" href=\"javascript:void(0)\" title=\"Prev\">\n      <i class=\"fa fa-backward\"></i>\n    </a>\n  </li>\n  <ng-container *ngIf=\"!pager.isEmpty\">\n    <li *ngFor=\"let page of pager.pages\" [class.active]=\"pager.isActive(page)\" class=\"page-item\">\n      <a (click)=\"pager.goTo(page)\" class=\"page-link\" href=\"javascript:void(0)\">{{page + 1}}</a>\n    </li>\n  </ng-container>\n  <li *ngIf=\"showPrevNext\" [class.disabled]=\"!pager.hasNext\" class=\"page-item\">\n    <a (click)=\"pager.next()\" class=\"page-link\" href=\"javascript:void(0)\" title=\"Next\">\n      <i class=\"fa fa-forward\"></i>\n    </a>\n  </li>\n  <li *ngIf=\"showFirstLast\" [class.disabled]=\"!pager.hasLast\" class=\"page-item\">\n    <a (click)=\"pager.goToLast()\" class=\"page-link\" href=\"javascript:void(0)\" title=\"Last\">\n      <i class=\"fa fa-step-forward\"></i>\n    </a>\n  </li>\n  <li *ngIf=\"showBrief\" class=\"page-item disabled\">\n    <span class=\"page-link\">\n      {{pager.totalItems}} items / {{pager.count}} pages\n    </span>\n  </li>\n</ul>\n",
                        styles: [":host{display:block;margin-top:1rem;margin-bottom:1rem;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none}.pagination{margin:0}a:focus{box-shadow:none}"]
                    }] }
        ];
        PaginationComponent.propDecorators = {
            showBrief: [{ type: core.Input }],
            showPrevNext: [{ type: core.Input }],
            showFirstLast: [{ type: core.Input }],
            pager: [{ type: core.Input }]
        };
        return PaginationComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var PanelComponent = /** @class */ (function () {
        function PanelComponent() {
            this.toggleable = true;
            this.toggle = new common$1.Toggle().setIsOn(common$1.Toggle.ON);
        }
        PanelComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-panel',
                        template: "<div class=\"card\">\n  <div *ngIf=\"title\" class=\"card-header\">\n    {{title}}\n    <i *ngIf=\"toggleable && toggle.isOn\" (click)=\"toggle.close()\" class=\"fa fa-chevron-up pull-right\"></i>\n    <i *ngIf=\"toggleable && toggle.isOff\" (click)=\"toggle.open()\" class=\"fa fa-chevron-down pull-right\"></i>\n  </div>\n  <div *ngIf=\"toggle.isOn\" class=\"card-body\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                        styles: [":host{display:block}.card-body{overflow:hidden}.card-header .icon{float:right}"]
                    }] }
        ];
        PanelComponent.propDecorators = {
            title: [{ type: core.Input }],
            toggleable: [{ type: core.Input }]
        };
        return PanelComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var RadioGroupWithinFormComponent = /** @class */ (function (_super) {
        __extends(RadioGroupWithinFormComponent, _super);
        function RadioGroupWithinFormComponent(container) {
            return _super.call(this, container) || this;
        }
        RadioGroupWithinFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-radio-group-within-form',
                        template: "<div [formGroup]=\"formGroup\">\n  <ui-radio-group [formControlName]=\"name\" [options]=\"options\"></ui-radio-group>\n</div>\n",
                        styles: [":host{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        RadioGroupWithinFormComponent.ctorParameters = function () { return [
            { type: forms.ControlContainer }
        ]; };
        RadioGroupWithinFormComponent.propDecorators = {
            options: [{ type: core.Input }],
            name: [{ type: core.Input }]
        };
        return RadioGroupWithinFormComponent;
    }(angular.BaseControlWithinForm));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var RadioGroupComponent = /** @class */ (function (_super) {
        __extends(RadioGroupComponent, _super);
        function RadioGroupComponent() {
            var _this = _super !== null && _super.apply(this, arguments) || this;
            _this.randomId = "" + new Date().getTime() + Math.floor(Math.random() * 10000);
            return _this;
        }
        /**
         * @param {?} option
         * @return {?}
         */
        RadioGroupComponent.prototype.idOf = /**
         * @param {?} option
         * @return {?}
         */
        function (option) {
            return "checkbox-" + this.randomId + "-" + option[this.valueField];
        };
        RadioGroupComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-radio-group',
                        template: "<div *ngFor=\"let option of options\" class=\"form-check form-check-inline\">\n  <input (change)=\"select(option)\" [checked]=\"selected(option)\" [disabled]=\"disabled\" [id]=\"idOf(option)\"\n         class=\"form-check-input\" type=\"radio\"/>\n  <label [for]=\"idOf(option)\" class=\"form-check-label\">\n    {{option[labelField]}}\n  </label>\n</div>\n",
                        providers: [{
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: RadioGroupComponent,
                                multi: true,
                            }],
                        styles: ["label{margin-right:.5em}"]
                    }] }
        ];
        RadioGroupComponent.propDecorators = {
            disabled: [{ type: core.Input }],
            valueField: [{ type: core.Input }],
            labelField: [{ type: core.Input }],
            options: [{ type: core.Input }]
        };
        return RadioGroupComponent;
    }(angular.SelectValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var SelectBoxComponent = /** @class */ (function (_super) {
        __extends(SelectBoxComponent, _super);
        function SelectBoxComponent() {
            return _super.call(this) || this;
        }
        /**
         * @return {?}
         */
        SelectBoxComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        SelectBoxComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-select-box',
                        template: "<div class=\"dropdown\">\n  <ul class=\"dropdown-menu\">\n    <li *ngFor=\"let option of options\">\n      <a></a>\n    </li>\n  </ul>\n</div>\n",
                        providers: [
                            { provide: forms.NG_VALUE_ACCESSOR, multi: true, useExisting: SelectBoxComponent },
                        ],
                        styles: [""]
                    }] }
        ];
        /** @nocollapse */
        SelectBoxComponent.ctorParameters = function () { return []; };
        SelectBoxComponent.propDecorators = {
            options: [{ type: core.Input }]
        };
        return SelectBoxComponent;
    }(angular.SelectValueAccessor));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var TableComponent = /** @class */ (function () {
        function TableComponent() {
            this.items = [];
            this.sorter = new common$1.TableSorter().setFields(this.fields);
            this.size = {};
            this._fields = [];
        }
        Object.defineProperty(TableComponent.prototype, "fields", {
            get: /**
             * @return {?}
             */
            function () {
                return this._fields;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                if (this._fields !== value) {
                    this._fields = value;
                    this.sorter.fields = value;
                }
            },
            enumerable: true,
            configurable: true
        });
        Object.defineProperty(TableComponent.prototype, "sortable", {
            get: /**
             * @return {?}
             */
            function () {
                return this.sorter.enabled;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this.sorter.enabled = value;
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} order
         * @return {?}
         */
        TableComponent.prototype.orderCss = /**
         * @param {?} order
         * @return {?}
         */
        function (order) {
            switch (order) {
                case core$1.SortOrder.Asc:
                    return 'fa-sort-asc';
                case core$1.SortOrder.Desc:
                    return 'fa-sort-desc';
                case core$1.SortOrder.None:
                default:
                    return 'fa-sort';
            }
        };
        TableComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-table',
                        template: "<ng-container *ngIf=\"sorter\" #pager=\"uiPagination\" [totalItems]=\"items.length\" uiPagination>\n  <table class=\"table table-hover table-striped table-bordered\">\n    <thead>\n    <tr>\n      <th *ngFor=\"let field of fields\" #measure=\"uiMeasure\"\n          (click)=\"sorter.toggle(field)\" [class.sortable]=\"sortable && field.sortable\"\n          [ngClass]=\"field.type|typeName:'data-type-'\"\n          [style.width.px]=\"(measure.clientRect.width + movable.offset.x)||100\"\n          [title]=\"field.title\"\n          class=\"resizable\" uiMeasure>\n        {{field.title}}\n        <i *ngIf=\"field.sortable\" [ngClass]=\"orderCss(field.sortOrder)\" class=\"fa\"></i>\n        <div #movable=\"uiMovable\" (uiMoveStop)=\"measure.update()\" class=\"splitter\" uiMovable></div>\n      </th>\n    </tr>\n    </thead>\n    <tbody>\n    <tr *ngFor=\"let item of items | orderBy:sorter | slice:pager.begin:pager.end\">\n      <td *ngFor=\"let field of fields\" [ngClass]=\"field.type|typeName:'data-type-'\">\n        <span [title]=\"item[field.name]|format:field\">{{item[field.name]|format:field}}</span>\n      </td>\n    </tr>\n    </tbody>\n  </table>\n\n  <div class=\"row\">\n    <div class=\"col-md-10\">\n      <ui-pagination [pager]=\"pager\" [showBrief]=\"false\"></ui-pagination>\n    </div>\n    <div class=\"col-md-2\">\n      <select [(ngModel)]=\"pager.size\" class=\"form-control\" name=\"pageSize\">\n        <option value=\"10\">10</option>\n        <option value=\"20\">20</option>\n        <option value=\"50\">50</option>\n      </select>\n    </div>\n  </div>\n</ng-container>\n",
                        styles: ["@charset \"UTF-8\";:host{display:block}table{table-layout:fixed}table th{min-width:100px}.data-type-currency,.data-type-float,.data-type-int{text-align:right}th.sortable{cursor:pointer}th.sortable>.fa-sort-none{display:inline-block;font:14px/1 FontAwesome;font-size:inherit;text-rendering:auto;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}th.sortable>.fa-sort-none:after{content:\"\uF0DC\"}th.sortable>.fa-sort-asc,th.sortable>.fa-sort-desc{display:inline-block;font:14px/1 FontAwesome;font-size:inherit;text-rendering:auto;-webkit-font-smoothing:antialiased;-moz-osx-font-smoothing:grayscale}td>[title],th>[title]{display:block;text-overflow:ellipsis;white-space:nowrap;overflow:hidden}ui-pagination{margin:0}.resizable{position:relative;-webkit-user-select:none;-moz-user-select:none;-ms-user-select:none;user-select:none;white-space:nowrap;overflow:hidden}.resizable>.splitter{z-index:100;position:absolute;right:-3px;top:0;bottom:0;width:5px;background:rgba(0,0,0,.01);cursor:ew-resize}"]
                    }] }
        ];
        TableComponent.propDecorators = {
            items: [{ type: core.Input }],
            fields: [{ type: core.Input }],
            sortable: [{ type: core.Input }]
        };
        return TableComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var ToastListComponent = /** @class */ (function () {
        function ToastListComponent(toast) {
            this.toast = toast;
        }
        /**
         * @return {?}
         */
        ToastListComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
        };
        ToastListComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-toast-list',
                        template: "<div *ngIf=\"!toast.isEmpty\" class=\"tooltip\">\n  <div *ngFor=\"let item of toast.items\" class=\"tooltip-inner bg-success text-light mb-2\">\n    {{item.message}} ({{item.duration / 1000 | number:'1.0-0'}})\n  </div>\n</div>\n",
                        styles: [".tooltip{position:fixed;left:0;right:0;top:20vh;margin:auto;width:15em;opacity:1}"]
                    }] }
        ];
        /** @nocollapse */
        ToastListComponent.ctorParameters = function () { return [
            { type: angular.ToastService }
        ]; };
        return ToastListComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TooltipComponent = /** @class */ (function () {
        function TooltipComponent(tooltip) {
            this.tooltip = tooltip;
            this.rect = new core$1.Rect();
        }
        /**
         * @param {?} $event
         * @return {?}
         */
        TooltipComponent.prototype.resize = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            this.rect = this.tooltip.getRectFor($event.boundingClientRect);
        };
        TooltipComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-tooltip',
                        template: "<div (uiMeasure)=\"resize($event)\" [style.left.px]=\"rect.left\" [style.top.px]=\"rect.top\"\n     class=\"tooltip bs-tooltip-bottom\">\n  <div class=\"arrow\"></div>\n  <div class=\"tooltip-inner\">\n    <ng-content></ng-content>\n  </div>\n</div>\n",
                        styles: [":host{display:block}.tooltip{position:fixed;opacity:1}.tooltip.bs-tooltip-bottom .arrow{left:50%}"]
                    }] }
        ];
        /** @nocollapse */
        TooltipComponent.ctorParameters = function () { return [
            { type: angular.TooltipService }
        ]; };
        return TooltipComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TreeNodeComponent = /** @class */ (function () {
        function TreeNodeComponent() {
            this.toggle = new common$1.Toggle().setIsOn(common$1.Toggle.ON);
        }
        TreeNodeComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-tree-node',
                        template: "<ng-container *ngIf=\"data\">\n  <i *ngIf=\"data.items?.length && toggle.isOff\" (click)=\"toggle.open()\" class=\"fa fa-plus-square-o\"></i>\n  <i *ngIf=\"data.items?.length && toggle.isOn\" (click)=\"toggle.close()\" class=\"fa fa-minus-square-o\"></i>\n  <label>{{data.label}}</label>\n  <ul *ngIf=\"data && toggle.isOn\">\n    <li *ngFor=\"let item of data.items\">\n      <ui-tree-node [data]=\"item\"></ui-tree-node>\n    </li>\n  </ul>\n</ng-container>\n",
                        styles: [":host{display:block}ul{list-style:none;padding-left:2em}img{height:1em;vertical-align:baseline}"]
                    }] }
        ];
        TreeNodeComponent.propDecorators = {
            data: [{ type: core.Input }]
        };
        return TreeNodeComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var TypeAheadWithinFormComponent = /** @class */ (function (_super) {
        __extends(TypeAheadWithinFormComponent, _super);
        function TypeAheadWithinFormComponent(container) {
            return _super.call(this, container) || this;
        }
        TypeAheadWithinFormComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-type-ahead-within-form',
                        template: "<div [formGroup]=\"formGroup\">\n  <ui-type-ahead [formControlName]=\"name\" [items]=\"options\"></ui-type-ahead>\n</div>\n",
                        styles: [":host{display:block}ui-type-ahead{display:block}"]
                    }] }
        ];
        /** @nocollapse */
        TypeAheadWithinFormComponent.ctorParameters = function () { return [
            { type: forms.ControlContainer }
        ]; };
        TypeAheadWithinFormComponent.propDecorators = {
            options: [{ type: core.Input }],
            name: [{ type: core.Input }]
        };
        return TypeAheadWithinFormComponent;
    }(angular.BaseControlWithinForm));

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    /**
     * @template T
     */
    var TypeAheadComponent = /** @class */ (function () {
        function TypeAheadComponent() {
            this.dropDown = new common$1.Toggle();
            this.checker = new rxjs.Subject();
            this.displayField = 'name';
            this.placeholder = '-';
            this.formatter = this.defaultFormatter.bind(this);
            this.parser = this.defaultParser.bind(this);
            this.search = new core.EventEmitter();
            this.activeIndex = 0;
            this.term = '';
            this.disabled = false;
        }
        Object.defineProperty(TypeAheadComponent.prototype, "value", {
            get: /**
             * @return {?}
             */
            function () {
                return this._value;
            },
            set: /**
             * @param {?} value
             * @return {?}
             */
            function (value) {
                this._value = value;
                this.term = value && this.parser(value);
            },
            enumerable: true,
            configurable: true
        });
        /**
         * @param {?} value
         * @return {?}
         */
        TypeAheadComponent.prototype.defaultFormatter = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!value) {
                return '';
            }
            if (value.hasOwnProperty('format') && core$1.isFunction(value.format)) {
                return value.format();
            }
            else {
                return value[this.displayField];
            }
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TypeAheadComponent.prototype.defaultParser = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            if (!value) {
                return '';
            }
            if (value.hasOwnProperty('parse') && core$1.isFunction(value.format)) {
                return value.parse();
            }
            else {
                return value[this.displayField];
            }
        };
        /**
         * @return {?}
         */
        TypeAheadComponent.prototype.ngOnInit = /**
         * @return {?}
         */
        function () {
            var _this = this;
            this.sub = this.checker.asObservable().pipe(operators.skipWhile((/**
             * @param {?} term
             * @return {?}
             */
            function (term) { return !term; })), operators.debounceTime(200), operators.tap((/**
             * @return {?}
             */
            function () {
                _this.search.emit(_this.term);
            }))).subscribe((/**
             * @return {?}
             */
            function () {
                _this.dropDown.open();
            }));
        };
        /**
         * @return {?}
         */
        TypeAheadComponent.prototype.ngOnDestroy = /**
         * @return {?}
         */
        function () {
            this.checker.complete();
            this.sub.unsubscribe();
        };
        /**
         * @param {?} value
         * @return {?}
         */
        TypeAheadComponent.prototype.writeValue = /**
         * @param {?} value
         * @return {?}
         */
        function (value) {
            this.value = value;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TypeAheadComponent.prototype.registerOnChange = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._change = fn;
        };
        /**
         * @param {?} fn
         * @return {?}
         */
        TypeAheadComponent.prototype.registerOnTouched = /**
         * @param {?} fn
         * @return {?}
         */
        function (fn) {
            this._touched = fn;
        };
        /**
         * @param {?} isDisabled
         * @return {?}
         */
        TypeAheadComponent.prototype.setDisabledState = /**
         * @param {?} isDisabled
         * @return {?}
         */
        function (isDisabled) {
            this.disabled = isDisabled;
        };
        /**
         * @param {?} item
         * @return {?}
         */
        TypeAheadComponent.prototype.select = /**
         * @param {?} item
         * @return {?}
         */
        function (item) {
            this.value = item;
            this.changed();
        };
        /**
         * @return {?}
         */
        TypeAheadComponent.prototype.clear = /**
         * @return {?}
         */
        function () {
            this.select(undefined);
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TypeAheadComponent.prototype.keydown = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if (['ArrowUp', 'ArrowDown', 'Home', 'End'].indexOf($event.key) !== -1) {
                $event.preventDefault();
                $event.stopPropagation();
            }
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TypeAheadComponent.prototype.keyup = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            /** @type {?} */
            var count = this.items.length;
            switch ($event.key) {
                case 'ArrowDown':
                    this.activeIndex = (this.activeIndex + 1) % count;
                    break;
                case 'ArrowUp':
                    this.activeIndex = (this.activeIndex + count - 1) % count;
                    break;
                case 'Home':
                    this.activeIndex = 0;
                    break;
                case 'End':
                    this.activeIndex = count - 1;
                    break;
                default:
                    return;
            }
            $event.preventDefault();
            $event.stopPropagation();
        };
        /**
         * @param {?} $event
         * @return {?}
         */
        TypeAheadComponent.prototype.keypress = /**
         * @param {?} $event
         * @return {?}
         */
        function ($event) {
            if ($event.key === 'Enter') {
                this.select(this.items[this.activeIndex]);
                this.dropDown.close();
                $event.preventDefault();
                $event.stopPropagation();
            }
        };
        /**
         * @protected
         * @return {?}
         */
        TypeAheadComponent.prototype.changed = /**
         * @protected
         * @return {?}
         */
        function () {
            if (this._change) {
                this._change(this.value);
            }
        };
        TypeAheadComponent.decorators = [
            { type: core.Component, args: [{
                        selector: 'ui-type-ahead',
                        template: "<div (uiClickOutside)=\"dropDown.close()\">\n  <div class=\"input-group\">\n    <input #typeAhead=\"uiTypeAhead\" (keydown)=\"keydown($event)\" (keypress)=\"keypress($event)\"\n           (keyup)=\"keyup($event)\" (uiTypeAheadClose)=\"dropDown.close()\" (uiTypeAheadOpen)=\"dropDown.open()\"\n           (uiTypeAheadSearch)=\"search.emit($event)\" [(ngModel)]=\"term\" class=\"form-control\"\n           name=\"term\" type=\"text\" uiTypeAhead\n    />\n    <div class=\"input-group-append\">\n      <button (click)=\"clear()\" class=\"btn btn-primary\" type=\"button\">X</button>\n    </div>\n  </div>\n  <div *ngIf=\"dropDown.isOn\" class=\"dropdown-menu\">\n    <div *ngIf=\"!items.length\" class=\"dropdown-item not-found\">{{placeholder}}</div>\n    <div *ngFor=\"let item of items; let index = index\" (click)=\"select(item);dropDown.close()\"\n         [class.active]=\"index === activeIndex\"\n         [innerHTML]=\"formatter(item)\"\n         class=\"dropdown-item\">\n    </div>\n  </div>\n</div>\n\n",
                        providers: [{
                                provide: forms.NG_VALUE_ACCESSOR,
                                useExisting: TypeAheadComponent,
                                multi: true,
                            }],
                        styles: [":host{display:inline-block;position:relative}.dropdown-menu{display:block;width:100%;top:initial}.dropdown-item.not-found{color:#dc3545}"]
                    }] }
        ];
        TypeAheadComponent.propDecorators = {
            items: [{ type: core.Input }],
            displayField: [{ type: core.Input }],
            placeholder: [{ type: core.Input }],
            formatter: [{ type: core.Input }],
            parser: [{ type: core.Input }],
            search: [{ type: core.Output }],
            disabled: [{ type: core.Input }]
        };
        return TypeAheadComponent;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var FieldCssPipe = /** @class */ (function () {
        function FieldCssPipe() {
        }
        /**
         * @param {?} field
         * @return {?}
         */
        FieldCssPipe.prototype.transform = /**
         * @param {?} field
         * @return {?}
         */
        function (field) {
            if (!field) {
                return '';
            }
            /** @type {?} */
            var cssList = ['ui-model-field', "ui-model-field-" + field.name];
            if (field.css) {
                if (core.isDevMode()) {
                    console.warn('You specified a custom css, so I no longer automatically add `col-md-*` class.');
                }
                cssList.push(field.css);
            }
            else {
                if (field.isGroup || field.isArray) {
                    cssList.push('col-md-12');
                }
                else {
                    cssList.push('col-md-6');
                }
            }
            return cssList.join(' ');
        };
        FieldCssPipe.decorators = [
            { type: core.Pipe, args: [{
                        name: 'fieldCss',
                    },] }
        ];
        return FieldCssPipe;
    }());

    /**
     * @fileoverview added by tsickle
     * @suppress {checkTypes,constantProperty,extraRequire,missingOverride,missingReturn,unusedPrivateMembers,uselessCode} checked by tsc
     */
    var UiModelBootstrapModule = /** @class */ (function () {
        function UiModelBootstrapModule() {
        }
        UiModelBootstrapModule.decorators = [
            { type: core.NgModule, args: [{
                        imports: [
                            common.CommonModule,
                            forms.FormsModule,
                            forms.ReactiveFormsModule,
                            angular.UiModelModule,
                        ],
                        declarations: [
                            ModalComponent,
                            ModalSuccessComponent,
                            ModalInfoComponent,
                            ModalErrorComponent,
                            ModalConfirmComponent,
                            ModalFormComponent,
                            ModalPromptComponent,
                            ModalWarningComponent,
                            PaginationComponent,
                            PanelComponent,
                            RadioGroupComponent,
                            RadioGroupWithinFormComponent,
                            TableComponent,
                            TreeNodeComponent,
                            CalendarComponent,
                            TypeAheadComponent,
                            TypeAheadWithinFormComponent,
                            TooltipComponent,
                            FieldErrorComponent,
                            FormGroupComponent,
                            FormArrayComponent,
                            FormControlComponent,
                            DatePickerComponent,
                            SelectBoxComponent,
                            MultiSelectBoxComponent,
                            FieldCssPipe,
                            ModalListComponent,
                            ToastListComponent,
                        ],
                        exports: [
                            ModalComponent,
                            ModalSuccessComponent,
                            ModalInfoComponent,
                            ModalErrorComponent,
                            ModalFormComponent,
                            ModalConfirmComponent,
                            ModalPromptComponent,
                            ModalWarningComponent,
                            PaginationComponent,
                            PanelComponent,
                            RadioGroupComponent,
                            RadioGroupWithinFormComponent,
                            TableComponent,
                            TreeNodeComponent,
                            CalendarComponent,
                            TypeAheadComponent,
                            TypeAheadWithinFormComponent,
                            TooltipComponent,
                            FieldErrorComponent,
                            FormGroupComponent,
                            FormArrayComponent,
                            FormControlComponent,
                            DatePickerComponent,
                            SelectBoxComponent,
                            ModalListComponent,
                            ToastListComponent,
                            FieldCssPipe,
                        ],
                    },] }
        ];
        return UiModelBootstrapModule;
    }());

    exports.CalendarComponent = CalendarComponent;
    exports.DatePickerComponent = DatePickerComponent;
    exports.FieldCssPipe = FieldCssPipe;
    exports.FieldErrorComponent = FieldErrorComponent;
    exports.FormArrayComponent = FormArrayComponent;
    exports.FormControlComponent = FormControlComponent;
    exports.FormGroupComponent = FormGroupComponent;
    exports.ModalComponent = ModalComponent;
    exports.ModalConfirmComponent = ModalConfirmComponent;
    exports.ModalErrorComponent = ModalErrorComponent;
    exports.ModalFormComponent = ModalFormComponent;
    exports.ModalInfoComponent = ModalInfoComponent;
    exports.ModalPromptComponent = ModalPromptComponent;
    exports.ModalSuccessComponent = ModalSuccessComponent;
    exports.ModalWarningComponent = ModalWarningComponent;
    exports.PaginationComponent = PaginationComponent;
    exports.PanelComponent = PanelComponent;
    exports.RadioGroupComponent = RadioGroupComponent;
    exports.RadioGroupWithinFormComponent = RadioGroupWithinFormComponent;
    exports.SelectBoxComponent = SelectBoxComponent;
    exports.TableComponent = TableComponent;
    exports.TooltipComponent = TooltipComponent;
    exports.TreeNodeComponent = TreeNodeComponent;
    exports.TypeAheadComponent = TypeAheadComponent;
    exports.TypeAheadWithinFormComponent = TypeAheadWithinFormComponent;
    exports.UiModelBootstrapModule = UiModelBootstrapModule;
    exports.ɵa = MultiSelectBoxComponent;
    exports.ɵb = ModalListComponent;
    exports.ɵc = ToastListComponent;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ui-model-angular-bootstrap.umd.js.map
